"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class SomaticInformation(ProtocolElement):
    """
    The somatic information.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import reports as reports_6_8_0

        return {
            "org.gel.models.report.avro.SomaticInformation": reports_6_8_0.SomaticInformation,
        }

    __slots__ = [
        "histologySubtype",
        "primaryHistology",
        "primarySite",
        "sampleSource",
        "siteSubtype",
        "tumourOrigin",
    ]

    def __init__(
        self,
        histologySubtype=None,
        primaryHistology=None,
        primarySite=None,
        sampleSource=None,
        siteSubtype=None,
        tumourOrigin=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_8_0.SomaticInformation model.

        :param histologySubtype:
            The histology subtype
        :type histologySubtype: None | str
        :param primaryHistology:
            The primary histology
        :type primaryHistology: None | str
        :param primarySite:
            The primary site
        :type primarySite: None | str
        :param sampleSource:
            The sample source, e.g. blood-bone marrow, cell-line, pancreatic
        :type sampleSource: None | str
        :param siteSubtype:
            The primary site subtype
        :type siteSubtype: None | str
        :param tumourOrigin:
            The tumour origin
        :type tumourOrigin: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.8.0"
